SystemOrganization addCategory: #'VideoForSqueak-Morphic'!
SystemOrganization addCategory: #'VideoForSqueak-Core'!

Object subclass: #ParameterDescription
	instanceVariableNames: 'name type label target getSelector options help keepRatio value originalValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!ParameterDescription class methodsFor: 'instance creation' stamp: 'dgd 8/10/2004 20:10'!
booleanParameterNamed: nameSymbol label: labelString value: anObject help: helpString 
	^ self new
		initializeName: nameSymbol 
		type: #boolean
		label: labelString
		value: anObject
		options: nil
		help: helpString! !

!ParameterDescription class methodsFor: 'instance creation' stamp: 'dgd 8/10/2004 20:11'!
extentParameterNamed: nameSymbol label: labelString value: anObject help: helpString 
	^ self new
		initializeName: nameSymbol
		type: #extent
		label: labelString
		value: anObject
		options: nil
		help: helpString! !

!ParameterDescription class methodsFor: 'instance creation' stamp: 'dgd 8/9/2004 20:13'!
new
	"answer a new instance of the receiver"
	^ super new initialize! !

!ParameterDescription class methodsFor: 'instance creation' stamp: 'dgd 8/10/2004 20:12'!
optionParameterNamed: nameSymbol label: labelString value: anObject options: aCollection help: helpString 
	^ self new
		initializeName: nameSymbol
		type: #option
		label: labelString
		value: anObject
		options: aCollection
		help: helpString! !

!ParameterDescription methodsFor: 'creation' stamp: 'dgd 8/10/2004 14:17'!
asBooleanMorph
	| cb lab |
	cb := EtoyUpdatingThreePhaseButtonMorph checkBox.
	cb
		target: self;
		actionSelector: #switchValue;
		getSelector: #value.
	help isEmpty ifFalse: [cb setBalloonText: help].
	""
	lab := StringMorph contents: ' ' , label.
	lab setBalloonText: help.
	help isEmpty ifFalse: [lab setBalloonText: help].
	""
	^self inARow: { 
				cb.
				lab}! !

!ParameterDescription methodsFor: 'creation' stamp: 'dgd 8/10/2004 12:36'!
asExtentMorph
	| lab x y kr |
	lab := StringMorph contents: label , ': '.
	help isEmpty
		ifFalse: [lab setBalloonText: help].
	""
	x := UpdatingNumericStringMorph on: self selector: #getPointX.
	x putSelector: #setPointX:.
	x min: 16.
	x max: 640.
	x setBalloonText: 'width in pixels' translated.
	""
	y := UpdatingNumericStringMorph on: self selector: #getPointY.
	y putSelector: #setPointY:.
	y min: 12.
	y max: 480.
	y setBalloonText: 'height in pixels' translated.
	""
	kr := EtoyUpdatingThreePhaseButtonMorph checkBox.
	kr target: self;
		 actionSelector: #switchKeepRatio;
		 getSelector: #keepRatio.
	kr setBalloonText: 'keep ratio' translated.
	""
	^ self inARow: {lab. StringMorph contents: ' width=' translated. self inABox: x. StringMorph contents: ' height=' translated. self inABox: y. StringMorph contents: '  '. kr}! !

!ParameterDescription methodsFor: 'creation' stamp: 'dgd 8/10/2004 12:06'!
asMorph
	type == #boolean
		ifTrue: [^ self asBooleanMorph].
	type == #extent
		ifTrue: [^ self asExtentMorph].
	type == #option
		ifTrue: [^ self asOptionMorph].
	""
	^ StringMorph contents: 'unknown type: ' , type asString! !

!ParameterDescription methodsFor: 'creation' stamp: 'dgd 8/10/2004 12:33'!
asOptionMorph
	| lab button |
	lab := StringMorph contents: label , ': '.
	help isEmpty
		ifFalse: [lab setBalloonText: help].
	""
	button := UpdatingSimpleButtonMorph newWithLabel: '-'.
	button target: self;
		 wordingSelector: #wordingForOption;
		 actionSelector: #showOptions;

		 color: Color white;
		 borderWidth: 1;
		 borderColor: Color black;
		 cornerStyle: #square.
help isEmpty
		ifFalse: [button setBalloonText: help].
	""
	^ self inARow: {lab. button}! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:17'!
getPointX
	^(self value) x! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:17'!
getPointY
	^(self value) y! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/10/2004 20:14'!
hasChanged
	^ value ~= originalValue! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/9/2004 19:10'!
inABox: aMorph 
	"private - answer a row with the given morphs"
	| box |
	box := AlignmentMorph newRow.
	box color: Color white.
	box borderWidth: 1.
	box borderColor: Color black.
	""
	box addMorphBack: aMorph.
	""
	^ box! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/9/2004 17:38'!
inARow: aCollection 
	"private - answer a row with the given morphs"
	| row |
	row := AlignmentMorph newRow.
	row color: Color transparent.
	""
	aCollection
		do: [:each | row addMorphBack: each].
	""
	^ row! !

!ParameterDescription methodsFor: 'initialization' stamp: 'dgd 8/9/2004 20:23'!
initialize
	"initialize the receiver"


	keepRatio := true! !

!ParameterDescription methodsFor: 'initialization' stamp: 'dgd 8/10/2004 20:09'!
initializeName: nameSymbol type: typeSymbol label: labelString value: anObject options: aCollection help: helpString 
	"initialize the receiver"
	name := nameSymbol.
	type := typeSymbol.
	label := labelString.
	value := originalValue := anObject.
	options := aCollection.
	help := helpString! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/9/2004 20:23'!
keepRatio
	^keepRatio! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/10/2004 20:09'!
name
	"answer the receiver's name"
	^ name! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:17'!
setPointX: aNumber 
	| newX currentX newY |
	newX := aNumber asInteger min: 640 max: 16.
	currentX := self getPointX.
	newX = currentX ifTrue: [^self].
	newY := keepRatio 
				ifTrue: [(newX / currentX * self getPointY) rounded]
				ifFalse: [self getPointY].
	""
	self value: newX @ newY! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:17'!
setPointY: aNumber 
	| newY currentY newX |
	newY := aNumber asInteger min: 480 max: 12.
	currentY := self getPointY.
	newY = currentY ifTrue: [^self].
	newX := keepRatio 
				ifTrue: [(newY / currentY * self getPointX) rounded]
				ifFalse: [self getPointX].
	""
	self value: newX @ newY! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:17'!
showOptions
	| menu |
	menu := MenuMorph new.
	menu color: Color white.
	menu borderWidth: 1.
	menu borderColor: Color black.
	menu cornerStyle: #square.
	options do: 
			[:pair | 
			""

			menu 
				add: pair first
				target: self
				selector: #value:
				argumentList: { 
						pair second}].
	menu popUpInWorld! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/9/2004 20:24'!
switchKeepRatio
	keepRatio := keepRatio not! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/10/2004 14:18'!
switchValue
	value := value not ! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/10/2004 14:13'!
value
^value! !

!ParameterDescription methodsFor: 'accessing' stamp: 'dgd 8/10/2004 14:13'!
value: anObject
	value _anObject! !

!ParameterDescription methodsFor: 'copying' stamp: 'tk 3/26/2007 12:15'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

	super veryDeepFixupWith: deepCopier.
	target _ deepCopier references at: target ifAbsent: [target].
! !

!ParameterDescription methodsFor: 'copying' stamp: 'tk 3/26/2007 12:15'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
name _ name veryDeepCopyWith: deepCopier.
type _ type veryDeepCopyWith: deepCopier.
label _ label veryDeepCopyWith: deepCopier.
"target _ target		Copy weakly."
getSelector _ getSelector veryDeepCopyWith: deepCopier.
options _ options veryDeepCopyWith: deepCopier.
help _ help veryDeepCopyWith: deepCopier.
keepRatio _ keepRatio veryDeepCopyWith: deepCopier.
value _ value veryDeepCopyWith: deepCopier.
originalValue _ originalValue veryDeepCopyWith: deepCopier.
! !

!ParameterDescription methodsFor: 'private' stamp: 'dgd 8/10/2004 14:18'!
wordingForOption
	| option wording |
	option := self value.
	wording := options detect: [:pair | pair second = option]
				ifNone: [^'<unknown option>' translated].
	^wording first! !

Object subclass: #VideoDevice
	instanceVariableNames: 'isSleeping isExecutor brightness contrast implementation lastErrorTimestamp'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!VideoDevice commentStamp: 'dgd 8/1/2004 21:06' prior: 0!
VideoDevice is the access point for Video4Squeak framework.

How to use:
	VideoDevice default.

!

!VideoDevice class methodsFor: 'instance creation' stamp: 'dgd 8/5/2004 19:19'!
default
	"answer the default video device"
	" 
	VideoDevice default.  
	"
	^ self implementation: self firstAvailableDeviceImplementor! !

!VideoDevice class methodsFor: 'enumerating' stamp: 'dgd 8/5/2004 19:30'!
descriptions
	"answer a collection of VideoDeviceDescription of available  
	video devices"
	" 
	VideoDevice descriptions.  
	"
	| result |
	result := Set new.
	self workingImplementors
		do: [:each | result addAll: each descriptions].
	""
	^ result ! !

!VideoDevice class methodsFor: 'instance creation' stamp: 'dgd 3/6/2007 14:05'!
firstAvailableDeviceImplementor
	"private - answer the first available video device implementor"
	| descriptions |
	descriptions := self descriptions asSortedCollection: [:x :y | x id <= y id].
	descriptions isEmpty ifTrue: [^self error: 'no video devices detected'].
	descriptions do: [:eachDescription | 
		[ ^ eachDescription newImplementor ]
			on: Error
			do: [:exception | ]
	].
! !

!VideoDevice class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 20:16'!
implementation: anImplementor 
	"answer an instance of the receiver using the given  
	implementor"
	^ self new initializeImplementation: anImplementor! !

!VideoDevice class methodsFor: 'initialize-release' stamp: 'dgd 7/28/2004 21:14'!
initialize
	" 
	VideoDevice initialize. 
	"
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self! !

!VideoDevice class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 20:30'!
new
	"answer a new instance of the receiver"
	^ super new initialize ! !

!VideoDevice class methodsFor: 'registry' stamp: 'dgd 7/11/2004 20:45'!
register: anObject 
	"register anObject to receive the finalization signal"
	WeakArray isFinalizationSupported
		ifFalse: [^ self].
	self registry add: anObject! !

!VideoDevice class methodsFor: 'registry' stamp: 'dgd 7/11/2004 20:45'!
registry
	"anwer the registry for finalization"
	WeakArray isFinalizationSupported
		ifFalse: [^ nil].
	^ Registry
		ifNil: [Registry := WeakRegistry new]! !

!VideoDevice class methodsFor: 'system startup' stamp: 'dgd 7/11/2004 20:46'!
shutDown: quitting 
	quitting ifFalse:[^self].
""

			self allSubInstances
				do: [:each | each sleep]! !

!VideoDevice class methodsFor: 'system startup' stamp: 'dgd 7/11/2004 20:46'!
startUp: resuming 
	resuming ifFalse:[^self].
""
		
			self allSubInstances
				do: [:each | each awake]! !

!VideoDevice class methodsFor: 'initialize-release' stamp: 'dgd 7/28/2004 21:15'!
unload
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self! !

!VideoDevice class methodsFor: 'registry' stamp: 'dgd 7/11/2004 20:45'!
unregister: anObject 
	WeakArray isFinalizationSupported
		ifFalse: [^ self].
	self registry
		remove: anObject
		ifAbsent: []! !

!VideoDevice class methodsFor: 'enumerating' stamp: 'dgd 3/5/2007 10:30'!
workingImplementors
	"private - answer a collection of implementors working on the 
	current environment" 
	^ VideoDeviceImplementor allSubclasses select: [:each | each workOnCurrentEnvironment].
! !

!VideoDevice methodsFor: 'finalization' stamp: 'dgd 8/1/2004 21:07'!
actAsExecutor
	"prepare the receiver to act as executor for any resources associated with it"
	super actAsExecutor.
	"an executor will not to go sleep becouse the original instance 
	will close the device for its own"
	isExecutor := true! !

!VideoDevice methodsFor: 'configuration' stamp: 'dgd 8/10/2004 21:27'!
applyParameters: aCollection 
	"apply the (possible changed) collection of parameters"
	self isPoisoned
		ifFalse: [self close].
	implementation applyParameters: aCollection.
	self isPoisoned
		ifFalse: [self open].
! !

!VideoDevice methodsFor: 'sleeping' stamp: 'dgd 8/1/2004 20:14'!
awake
	"if the receiver is sleeping, awake it"
	isExecutor
		ifTrue: [^ self].
	""
	isSleeping
		ifFalse: [^ self].
	""
	self open.
	isSleeping := false! !

!VideoDevice methodsFor: 'private' stamp: 'dgd 3/5/2007 10:35'!
benchmark
	"capture and display 100 frames from the device"
	| iterations time statistics |
	iterations := 100.
	time := Time
				millisecondsToRun: [""
					iterations
						timesRepeat: [self nextFrame display]].
	""
	Display restore.
	""
	statistics := String new writeStream.
	statistics nextPutAll: '------------------------------------------------------------'.
	statistics cr.
	statistics nextPutAll: 'Frame Extent: ' , self extent asString.
	statistics cr.
	statistics nextPutAll: 'Iterations: ' , iterations asString.
	statistics cr.
	statistics nextPutAll: 'Ellapsed time:' , time asString , 'ms (each ' , (time / iterations) asFloat rounded asString , 'ms)'.
	statistics cr.
	statistics nextPutAll: 'Frames per second:' , (1000.0 / (time / iterations) roundTo: 0.01) asString.
	statistics cr.
	statistics nextPutAll: '------------------------------------------------------------'.
	statistics cr.
	""
	statistics contents openInWorkspaceWithTitle: 'benchmark'! !

!VideoDevice methodsFor: 'dying / reviving' stamp: 'dgd 8/1/2004 20:16'!
bePoisoned
	"change the receiver to be poisoned"
	lastErrorTimestamp := Time millisecondClockValue.
	[self closeIfCorresponds]
		on: Error
		do: [:exception | ]! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/11/2004 20:55'!
brightness
	"answer the receiver's brightness"
	^ brightness! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/28/2004 17:08'!
brightness: aNumber 
	"change the receiver's brightness"
	
	brightness := aNumber asFloat min: 1.0 max: -1.0! !

!VideoDevice methodsFor: 'private' stamp: 'dgd 8/9/2004 19:44'!
changedExtent
self triggerEvent:#extent! !

!VideoDevice methodsFor: 'opening / closing' stamp: 'dgd 8/1/2004 13:11'!
close
	"close the receiver"
	isSleeping
		ifTrue: [""
			isSleeping := false.
			^ self].
	""
	self isOpened
		ifFalse: [^ self error: 'device not opened'].
	""
	[implementation close]
		on: Error
		do: [:exception | exception].
	self class unregister: self! !

!VideoDevice methodsFor: 'private' stamp: 'dgd 8/1/2004 13:08'!
closedFrame
	"private"
	^ self frameColor: Color blue twiceDarker withMessage: 'closed' translated! !

!VideoDevice methodsFor: 'opening / closing' stamp: 'dgd 7/11/2004 20:48'!
closeIfCorresponds
	"close the receiver if it's opened, otherwise do nothing"
	self isOpened
		ifTrue: [self close]! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/11/2004 20:55'!
contrast
	"answer the receiver's contrast"
	^ contrast! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/28/2004 17:08'!
contrast: aNumber 
	"change the receiver's contrast"
	
	contrast := aNumber asFloat min: 1.0 max: -1.0! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:20'!
deviceID
	"answer the receiver's deviceID"
	^ implementation deviceID! !

!VideoDevice methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:19'!
extent
	"answer the receiver's extent"
	^implementation extent! !

!VideoDevice methodsFor: 'finalization' stamp: 'dgd 7/11/2004 20:49'!
finalize
	"the receiver is going to die, let's clean up"
	
	self closeIfCorresponds! !

!VideoDevice methodsFor: 'private' stamp: 'dgd 8/1/2004 12:49'!
frameColor: aColor withMessage: aString 
	"private - create a frame of the given color with aString as the message"
	| result |
	result := Form extent: self extent depth: 32.
	result fillColor: aColor.
	result getCanvas
		drawString: aString
		at: 5 @ 2
		font: Preferences windowTitleFont
		color: Color lightGreen.
	^ result! !

!VideoDevice methodsFor: 'initialization' stamp: 'dgd 8/1/2004 17:58'!
initialize
	"initialize the receiver"

	isSleeping := false.

	isExecutor := false.
	""
	brightness := 0.0.
	contrast := 0.0! !

!VideoDevice methodsFor: 'initialization' stamp: 'dgd 8/9/2004 19:43'!
initializeImplementation: anImplementor 
	"initialize the receiver's description"
	implementation := anImplementor.
implementation when: #extent
		send: #changedExtent
		to: self! !

!VideoDevice methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 20:19'!
isOpened
	"answer whatever the receiver is opened"
	^ implementation isOpened! !

!VideoDevice methodsFor: 'dying / reviving' stamp: 'dgd 8/1/2004 19:59'!
isPoisoned
	"answer whatever the receiver is poisoned"
	^ lastErrorTimestamp notNil! !

!VideoDevice methodsFor: 'dying / reviving' stamp: 'dgd 8/1/2004 20:51'!
isTimeToRevive
	"answer if it's time to try to revive the receiver"
	| elapsed |
	self isPoisoned
		ifFalse: [^ false].
	elapsed := Time millisecondsSince: lastErrorTimestamp.
	^ elapsed > 5000! !

!VideoDevice methodsFor: 'capturing' stamp: 'dgd 3/5/2007 10:35'!
nextFrame
	"answer the next frame from the device represented by the  
	receiver"
	| result |
	self tryToReviveIfCorresponds.
	self isPoisoned
		ifTrue: [^self poisonedFrame].
	self isOpened
		ifFalse: [^self closedFrame].
	
	result := nil.
	[
		result := implementation nextFrameWithBrightness: self brightness contrast: self contrast.
	] 
			on: Error
			do: [:exception | 
				self bePoisoned.
				result := self poisonedFrame.
			].
	^ result.
! !

!VideoDevice methodsFor: 'opening / closing' stamp: 'dgd 8/10/2004 21:27'!
open
	"open the device represented by the receiver"
	self isOpened
		ifTrue: [^ self error: 'device already opened'].
	""
	[implementation open.
	self class register: self.
self triggerEvent: #extent.
	isSleeping := false]
		on: Error
		do: [:exception | self bePoisoned]! !

!VideoDevice methodsFor: 'opening / closing' stamp: 'dgd 7/11/2004 20:48'!
openIfCorresponds
	"open the receiver if it isn't opened, otherwise do nothing"
	self isOpened
		ifFalse: [self open]! !

!VideoDevice methodsFor: 'configuration' stamp: 'dgd 8/10/2004 14:59'!
parameters
	"answer a collection of parameters to configure the receiver"
	^ implementation parameters! !

!VideoDevice methodsFor: 'private' stamp: 'dgd 8/1/2004 20:47'!
poisonedFrame
	"private"
	^ self
		frameColor: Color red muchDarker
		withMessage: ('no connected video device id: {1}' translated format: {self deviceID})! !

!VideoDevice methodsFor: 'sleeping' stamp: 'dgd 8/1/2004 13:11'!
sleep
	"if the receiver is opened, put it to sleep"
	isExecutor
		ifTrue: [^ self].
	""
	self isOpened
		ifFalse: [^ self].
	""
	self close.
	isSleeping := true! !

!VideoDevice methodsFor: 'dying / reviving' stamp: 'dgd 8/1/2004 20:51'!
tryToRevive
	"private - trying to revive the receiver"
	self flag: #todo.
	"try to connect to another device if the current deviceID is  
	unavailable."
	""
	lastErrorTimestamp := nil.
	self open! !

!VideoDevice methodsFor: 'dying / reviving' stamp: 'dgd 8/1/2004 20:12'!
tryToReviveIfCorresponds
	"private - try to revive if it's time to"
	self isTimeToRevive
		ifTrue:[
	self tryToRevive]! !

Object subclass: #VideoDeviceImplementor
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!VideoDeviceImplementor commentStamp: 'dgd 7/28/2004 17:31' prior: 0!
This class is the superclass for the Implementor hierarchy for the Bridge composed with VideoDevice.

VideoDevice holds an implementor and it can be changed on the fly.

It allows, for instance, to switch the implementor base on the operative system where Squeak is being started.
!

VideoDeviceImplementor subclass: #TestDeviceImplementor
	instanceVariableNames: 'opened extent type isShowingTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!TestDeviceImplementor class methodsFor: 'enumerating' stamp: 'dgd 8/5/2004 19:26'!
descriptions
	"answer a collection of VideoDeviceDescription of available  
	video devices"

	^{ 
		self descriptionForId: 10 name: 'Test Video Device'}! !

!TestDeviceImplementor class methodsFor: 'testing' stamp: 'dgd 7/28/2004 17:34'!
workOnCurrentEnvironment
	"Answer whatever ther receiver can work on the current  
	environment.  
	 
	Usually the platform name is used to decide"
	"the test video device always works"
	^ true! !

!TestDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 8/10/2004 21:18'!
applyParameters: aCollection 
	"apply the (possible changed) collection of parameters"

	aCollection
		do: [:parameter | 
			parameter name == #extent
				ifTrue: [self extent: parameter value].
			parameter name == #type
				ifTrue: [type := parameter value].
			parameter name == #isShowingTime
				ifTrue: [isShowingTime := parameter value]]! !

!TestDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:34'!
close
	"private - close the receiver"
	opened := false! !

!TestDeviceImplementor methodsFor: 'private' stamp: 'dgd 8/9/2004 21:04'!
colorBars
	| result canvas testColors barWidth |
	result := Form extent: self extent depth: 32.
	""
	result fillColor: Color black.
	canvas := result getCanvas.
	""
	testColors :=  (Color cyan wheel: 32).
	barWidth := result width // testColors size.
	""
	testColors
		withIndexDo: [:color :index | ""
			canvas
				fillRectangle: (index - 1 * barWidth @ 0 rect: index * barWidth @ result height)
				color: color].
	^ result! !

!TestDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:07'!
deviceID
	"answer the receiver's deviceID"
	^ 10! !

!TestDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 8/10/2004 18:23'!
extent
	"answer the receiver's extent"
	^ extent! !

!TestDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 8/10/2004 19:41'!
extent: aPoint 
	"change the receiver's extent"
	extent = aPoint
		ifTrue: [^ self].
""
extent _ aPoint.
self triggerEvent:#extent! !

!TestDeviceImplementor methodsFor: 'initialization' stamp: 'dgd 11/3/2006 15:02'!
initialize
	"initialize the receiver"

	super initialize.

	type := #lenna.
	"type := #colorBars."
	isShowingTime := true.
	opened := true.
	extent := 320 @ 240.
! !

!TestDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:34'!
isOpened
	"answer whatever the receiver is opened"
	^ opened! !

!TestDeviceImplementor methodsFor: 'private' stamp: 'yo 10/15/2007 16:36'!
lenna
	^ (Form extent: 320 @ 240 depth: 32) fillColor: Color blue.
	"It had a picture of  nice looking woman famous in the CG field.  If you still see the picture go to Internet and not look at an educational environment for kids."! !

!TestDeviceImplementor methodsFor: 'capturing' stamp: 'dgd 3/5/2007 10:33'!
nextFrameWithBrightness: brightnessFloat contrast: contrastFloat 
	"answer the next frame from the device represented by the receiver"
	| result |
	result := (type == #lenna)
					ifTrue: [self scaledLenna]
					ifFalse: [self colorBars].
	isShowingTime ifTrue: [
		result getCanvas 
				drawString: Time now print24
				at: 5 @ 2
				font: Preferences windowTitleFont
				color: Color white.
	].
	^ result.
! !

!TestDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:34'!
open
	"open the device represented by the receiver"
	opened := true! !

!TestDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 8/10/2004 20:16'!
parameters
	"answer a collection of parameters to configure the receiver"
	| extentParameter showTimeParameter typeParameter |
	extentParameter := ParameterDescription
				extentParameterNamed: #extent
				label: 'Frame extent' translated
				value: extent
				help: 'the frame extent in pixels' translated.
	typeParameter := ParameterDescription
				optionParameterNamed: #type
				label: 'Type' translated
				value: type
				options: {{'Lenna'. #lenna}. {'Color Bars'. #colorBars}}
				help: 'the type of the test image' translated.
	showTimeParameter := ParameterDescription
				booleanParameterNamed: #isShowingTime
				label: 'show time' translated
				value: isShowingTime
				help: 'the test image includes the time' translated.
	^ {extentParameter. typeParameter. showTimeParameter}! !

!TestDeviceImplementor methodsFor: 'private' stamp: 'dgd 8/9/2004 21:12'!
scaledLenna
	| lenna result warpBlt |
	lenna := self lenna.
	self extent = lenna extent
		ifTrue: [^ lenna].
	""
	result := Form extent: self extent depth: 32.
	warpBlt := WarpBlt current toForm: result.
	warpBlt sourceForm: lenna.
	warpBlt cellSize: 2;
		 combinationRule: Form over.
	warpBlt
		copyQuad: lenna boundingBox innerCorners
		toRect: (0 @ 0 extent: self extent).
	""
	^ result ! !

VideoDeviceImplementor subclass: #V4LDeviceImplementor
	instanceVariableNames: 'deviceHandle buffer deviceID desiredExtent desiredPalette'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 18:11'!
defaulfDevice
	"answer the default device for instances of the receiver"
	^ 0! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/6/2007 10:45'!
defaultExtent
	"answer the default extent for instances of the receiver"
	^ 320 @ 240! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 18:11'!
defaultPalette
	"answer the default extent for instances of the receiver"
	^ 0! !

!V4LDeviceImplementor class methodsFor: 'enumerating' stamp: 'dgd 3/5/2007 10:39'!
descriptionForDeviceID: deviceID 
	"answer the description for the device with the given ID"
	| buffer deviceName |
	buffer := ByteArray new: 32.
	[
		self deviceDescribe: deviceID in: buffer
	]
		on: Error
		do:[:err | buffer := ByteArray new: 32.].
	deviceName := buffer asString reject: [:each | each asciiValue = 0].
	^ deviceName.
! !

!V4LDeviceImplementor class methodsFor: 'enumerating' stamp: 'dgd 3/6/2007 14:07'!
descriptions
	"answer a collection of VideoDeviceDescription of available  
	video devices"
	" 
	Video4LinuxDeviceImplementor descriptions.  
	 
	Time millisecondsToRun:[  
		Video4LinuxDeviceImplementor descriptions  
	]  
	"
	| result |
	result := Set new.
	0 to: 9 do: [:deviceID | 
		| deviceName | 
		deviceName := self descriptionForDeviceID: deviceID.
		deviceName isEmpty ifFalse: [
			result add: (self descriptionForId: deviceID name: deviceName).
		].
	].
	^ result.
! !

!V4LDeviceImplementor class methodsFor: 'primitives' stamp: 'dgd 3/5/2007 10:39'!
deviceDescribe: deviceIDInteger in: deviceName 
	<primitive: 'primitiveDeviceDescribe' module:'VideoForLinuxPlugin'>
	^ self error: 'can''t describe device id ''' , deviceIDInteger , ''''.
! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:38'!
device: idInteger 
	"answer an instance of the receiver"
	^ self device: idInteger extent: self defaultExtent! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:38'!
device: idInteger extent: aPoint 
	"answer an instance of the receiver"
	^ self
		device: idInteger
		extent: aPoint
		palette: self defaultPalette! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:38'!
device: idInteger extent: aPoint palette: paletteInteger 
	"answer an instance of the receiver"
	^ self
		device: idInteger
		extent: aPoint
		palette: paletteInteger
		open: true! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:39'!
device: idInteger extent: aPoint palette: paletteInteger open: aBoolean 
	"answer an instance of the receiver"
	"VIDEO_PALETTE_RGB24 = 4. --> depth=24"
	"VIDEO_PALETTE_YUV420 = 10. --> depth=12"
	^ super new
		initializeDevice: idInteger
		extent: aPoint
		palette: paletteInteger
		open: aBoolean! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:39'!
extent: aPoint 
	"answer an instance of the receiver"
	^ self
		extent: aPoint
		palette: self defaultPalette! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:39'!
extent: aPoint palette: paletteInteger 
	"answer an instance of the receiver"
	^ self
		device: self defaulfDevice
		extent: aPoint
		palette: paletteInteger! !

!V4LDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 3/5/2007 10:39'!
newOpen: aBoolean 
	"answer an instance of the receiver"
	^ self
		device: self defaulfDevice
		extent: self defaultExtent
		palette: self defaultPalette
		open: aBoolean! !

!V4LDeviceImplementor class methodsFor: 'enumerating' stamp: 'dgd 8/20/2006 12:33'!
workOnCurrentEnvironment
	"Answer whatever ther receiver can work on the current  
	environment.  
	 
	Usually the platform name is used to decide"
		
	((Smalltalk respondsTo: #osVersion) and: [Smalltalk osVersion = 'linux-gnu'])
		ifTrue:[^ true].
	
	Smalltalk
		at:#SmalltalkImage
		ifPresent:[:klass |
			^ klass current osVersion = 'linux-gnu'
		].
	
	^ false.
! !

!V4LDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 8/10/2004 21:26'!
applyParameters: aCollection 
	"apply the (possible changed) collection of parameters"
	aCollection
		do: [:parameter | 
			parameter name == #extent
				ifTrue: [
					desiredExtent := parameter value.
					].
			parameter name == #palette
				ifTrue: [desiredPalette := parameter value]]! !

!V4LDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 3/7/2007 10:59'!
close
	"close the receiver"
	| formerDH |
	formerDH :=  deviceHandle.
	deviceHandle	:= nil.
	buffer			:= nil.
	self deviceClose: formerDH.
! !

!V4LDeviceImplementor methodsFor: 'primitives' stamp: 'dgd 2/28/2007 16:52'!
deviceClose: deviceInteger 
	<primitive: 'primitiveDeviceClose' module:'VideoForLinuxPlugin'>
	^ self error: 'can''t open device  ''' , deviceInteger asString , ''''! !

!V4LDeviceImplementor methodsFor: 'primitives' stamp: 'dgd 2/28/2007 16:52'!
deviceCreate: deviceIDInteger with: widthInteger height: heightInteger palette: paletteInteger 
	<primitive: 'primitiveDeviceCreate' module:'VideoForLinuxPlugin'>
	^ self error: 'can''t create device id ''' , deviceIDInteger asString , ''''! !

!V4LDeviceImplementor methodsFor: 'primitives' stamp: 'dgd 2/28/2007 16:52'!
deviceGetHeight: deviceInteger 
	<primitive: 'primitiveDeviceGetHeight' module:'VideoForLinuxPlugin'>
	^ self error: 'primitive failed for device  ''' , deviceInteger asString , ''''! !

!V4LDeviceImplementor methodsFor: 'primitives' stamp: 'dgd 2/28/2007 16:52'!
deviceGetWidth: deviceInteger 
	<primitive: 'primitiveDeviceGetWidth' module:'VideoForLinuxPlugin'>
	^ self error: 'primitive failed for device  ''' , deviceInteger asString , ''''! !

!V4LDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 8/5/2004 22:49'!
deviceID
"answer the receiver's deviceID"
	^ deviceID! !

!V4LDeviceImplementor methodsFor: 'primitives' stamp: 'dgd 3/6/2007 13:42'!
deviceNextFrame: deviceInteger into: bits brightness: brightnessFloat contrast: contrastFloat formDepth: formDepth
	<primitive: 'primitiveDeviceNextFrameIntoBrightnessContrastFormDepth' module:'VideoForLinuxPlugin'>
	^ self error: 'can''t capture frame in device  ''' , deviceInteger asString , ''''! !

!V4LDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 3/7/2007 10:55'!
extent
	"answer the receiver's extent"
	^ buffer isNil
			ifTrue: [ 320 @ 240 ]
			ifFalse: [ buffer extent ].
! !

!V4LDeviceImplementor methodsFor: 'initialization' stamp: 'dgd 3/6/2007 14:06'!
initializeDescription: aDescription 
	"initialiaze the receiver's description"
	super initializeDescription: aDescription.
	self
		initializeDevice: aDescription id
		extent: self class defaultExtent
		palette: self class defaultPalette
		open: true
! !

!V4LDeviceImplementor methodsFor: 'initialization' stamp: 'dgd 3/7/2007 10:58'!
initializeDevice: deviceIDInteger extent: aPoint palette: paletteInteger open: autoOpenBoolean 
	"initialize the receiver"
	deviceID			:= deviceIDInteger asInteger.
	desiredExtent	:= aPoint asIntegerPoint.
	desiredPalette	:= paletteInteger asInteger.
	deviceHandle	:= nil.
	buffer			:= nil.
	autoOpenBoolean ifTrue: [
		self open
	].
! !

!V4LDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 8/6/2004 18:52'!
isOpened
	"answer whatever the receiver is opened"
	^  deviceHandle notNil! !

!V4LDeviceImplementor methodsFor: 'capturing' stamp: 'dgd 3/7/2007 10:56'!
nextFrameWithBrightness: brightnessFloat contrast: contrastFloat 
	"answer the next frame from the device represented by the receiver"
	buffer unhibernate. "Just in case..."
	self 
		deviceNextFrame: deviceHandle
		into: buffer bits
		brightness: brightnessFloat asFloat
		contrast: contrastFloat asFloat
		formDepth: buffer depth.
	^ buffer "deepCopy"
! !

!V4LDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 3/7/2007 13:26'!
open
	"open the device represented by the receiver"
	| ext |
	deviceHandle := self 
								deviceCreate: deviceID
								with: desiredExtent x
								height: desiredExtent y
								palette: desiredPalette.
	ext := (self deviceGetWidth: deviceHandle) @ (self deviceGetHeight: deviceHandle).
	"32 and 16 bits forms are supported"
	buffer := Form extent: ext depth: 16 "32".
! !

!V4LDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 2/28/2007 17:29'!
palettes
	| palettes |
	palettes := OrderedCollection new.
	palettes add: {'DEFAULT - The palette the camera liknes most' translated. 0}.
	"palettes add: {'GREY - Linear greyscale' translated. 1}."
	"palettes add: {'HI240 - High 240 cube (BT848)' translated. 2}."
	"palettes add: {'RGB565 - 565 16 bit RGB' translated. 3}."
	palettes add: {'RGB24 - 24bit RGB' translated. 4}.
	palettes add: {'RGB32 - 32bit RGB' translated. 5}.
	"palettes add: {'RGB555 - 555 15bit RGB' translated. 6}."
	palettes add: {'YUV422 - YUV422 capture' translated. 7}.
	palettes add: {'YUYV' translated. 8}.
	"palettes add: {'UYVY' translated. 9}."
	palettes add: {'YUV420' translated. 10}.
	"palettes add: {'YUV411 - YUV411 capture' translated. 11}."
	"palettes add: {'RAW - RAW capture (BT848)' translated. 12}."
	"palettes add: {'YUV422P - YUV 4:2:2 Planar' translated. 13}."
	"palettes add: {'YUV411P - YUV 4:1:1 Planar' translated. 14}."
	palettes add: {'YUV420P - YUV 4:2:0 Planar' translated. 15}.
	"palettes add: {'YUV410P - YUV 4:1:0 Planar' translated. 16}."
	^ palettes.
! !

!V4LDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 2/28/2007 17:29'!
parameters
	"answer a collection of parameters to configure the receiver"
	| extentParameter paletteParameter |
	extentParameter := ParameterDescription
								extentParameterNamed: #extent
								label: 'Frame extent' translated
								value: desiredExtent
								help: 'the frame extent in pixels' translated.
	paletteParameter := ParameterDescription
								optionParameterNamed: #palette
								label: 'Palette' translated
								value: desiredPalette
								options: self palettes
								help: 'the palette of the test image' translated.
	^ {extentParameter. paletteParameter}! !

!V4LDeviceImplementor methodsFor: 'printing' stamp: 'dgd 3/5/2007 10:55'!
printOn: aStream 
	"append to aStream a sequence of characters that identifies  
	the receiver"
	super printOn: aStream.
	aStream
		nextPutAll: ', deviceHandle=';
		nextPutAll: deviceHandle asString;
		nextPutAll: ', deviceID:';
		nextPutAll: self deviceID asString.
! !

!VideoDeviceImplementor class methodsFor: 'private' stamp: 'dgd 7/28/2004 18:42'!
descriptionForId: anInteger name: aString 
	"private - answer a description for the given id and name"
	^ VideoDeviceImplementorDescription
		type: self
		id: anInteger
		name: aString ! !

!VideoDeviceImplementor class methodsFor: 'enumerating' stamp: 'dgd 8/5/2004 19:26'!
descriptions
	"answer a collection of VideoDeviceDescription of available 
	video devices"

	^self subclassResponsibility! !

!VideoDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 17:17'!
new
	"answer a new instance of the receiver"
	^ super new initialize! !

!VideoDeviceImplementor class methodsFor: 'instance creation' stamp: 'dgd 7/28/2004 20:21'!
newFromDescription: aDescription 
	"answer a new instance of the receiver represented by the  
	given description"
	^ self new initializeDescription: aDescription! !

!VideoDeviceImplementor class methodsFor: 'testing' stamp: 'dgd 7/28/2004 17:16'!
workOnCurrentEnvironment
	"Answer whatever ther receiver can work on the current  
	environment. 
	 
	Usually the platform name is used to decide"
	^ self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 8/10/2004 18:24'!
applyParameters: aCollection 
	"apply the (possible changed) collection of parameters"
	! !

!VideoDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:10'!
close
	"private - close the receiver"
	self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:38'!
description
	"answer the receiver's description"
	^ description! !

!VideoDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:37'!
deviceID
	"answer the receiver's deviceID"
	^ self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'accessing' stamp: 'dgd 7/28/2004 20:37'!
extent
	"answer the receiver's extent"
	^ self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'initialization' stamp: 'dgd 7/28/2004 17:17'!
initialize
	"initialize the receiver"
! !

!VideoDeviceImplementor methodsFor: 'initialization' stamp: 'dgd 7/28/2004 20:18'!
initializeDescription: aDescription 
"initialiaze the receiver's description"
	description := aDescription! !

!VideoDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:14'!
isOpened
	"answer whatever the receiver is opened"
	^ self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'capturing' stamp: 'dgd 3/5/2007 10:36'!
nextFrame
	"anseer the next frame from the device represented by the receiver"
	^ self nextFrameWithBrightness: 1.0 contrast: 1.0.
! !

!VideoDeviceImplementor methodsFor: 'capturing' stamp: 'dgd 3/5/2007 10:33'!
nextFrameWithBrightness: brightnessFloat contrast: contrastFloat 
	"answer the next frame from the device represented by the receiver"
	^self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'opening / closing' stamp: 'dgd 7/28/2004 17:11'!
open
	"open the device represented by the receiver"
	self subclassResponsibility! !

!VideoDeviceImplementor methodsFor: 'configuration' stamp: 'dgd 8/10/2004 14:59'!
parameters
	"answer a collection of parameters to configure the receiver"
	^ {}! !

Object subclass: #VideoDeviceImplementorDescription
	instanceVariableNames: 'type id name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!VideoDeviceImplementorDescription class methodsFor: 'instance creation' stamp: 'dgd 7/26/2004 19:08'!
type: aClass id: anInteger name: aString
	"answer a new instance of the receiver"
	^ self new initializeType: aClass id: anInteger name: aString! !

!VideoDeviceImplementorDescription methodsFor: 'comparing' stamp: 'dgd 7/26/2004 19:37'!
hash
	"Answer a SmallInteger whose value is related to the receiver's identity."
	^ (self type hash bitXor: self id hash)
		bitXor: self name hash! !

!VideoDeviceImplementorDescription methodsFor: 'accessing' stamp: 'dgd 7/26/2004 19:15'!
id
	"answer the receiver's id"
	^ id! !

!VideoDeviceImplementorDescription methodsFor: 'initialization' stamp: 'dgd 7/26/2004 19:08'!
initializeType: aClass id: anInteger name: aString 
	"initialize the receiver"
	type := aClass.
	id := anInteger.
	name := aString ! !

!VideoDeviceImplementorDescription methodsFor: 'accessing' stamp: 'dgd 7/26/2004 19:15'!
name
	"answer the receiver's name"
	^ name! !

!VideoDeviceImplementorDescription methodsFor: 'factory' stamp: 'dgd 7/28/2004 18:44'!
newImplementor
	"answer the implementor instance represented by the receiver"
	^ type newFromDescription: self! !

!VideoDeviceImplementorDescription methodsFor: 'printing' stamp: 'dgd 7/26/2004 19:15'!
printOn: aStream 
	"Append to aStream a sequence of characters that identifies 
	the receiver."
	super printOn: aStream.
	""
	aStream nextPutAll: ' name:';
		 nextPutAll: self name asString;
		 nextPutAll: ', id:';
		 nextPutAll: self id asString;
		 nextPutAll: ', type:';
		 nextPutAll: self type asString! !

!VideoDeviceImplementorDescription methodsFor: 'accessing' stamp: 'dgd 7/26/2004 19:16'!
type
	"answer the receiver's type"
	^ type! !

!VideoDeviceImplementorDescription methodsFor: 'comparing' stamp: 'dgd 7/26/2004 19:35'!
= aVideoDeviceDescription 
	"answer whatever the receiver is equivalent to  
	aVideoDeviceDescription"
	^ self class = aVideoDeviceDescription class
		and: [self type = aVideoDeviceDescription type]
		and: [self id = aVideoDeviceDescription id]
		and: [self name = aVideoDeviceDescription name] ! !

AlignmentMorph subclass: #VideoMorphConfiguration
	instanceVariableNames: 'target parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Morphic'!

!VideoMorphConfiguration class methodsFor: 'instance creation' stamp: 'dgd 8/9/2004 20:46'!
target: aVideoMorph parameters: aCollection 
	"answer a new instance of the receiver"
	^ self new initializeTarget: aVideoMorph parameters: aCollection! !

!VideoMorphConfiguration methodsFor: 'building' stamp: 'dgd 8/10/2004 20:13'!
build
	self
		addMorphBack: (StringMorph contents: 'Video Device Configuration' translated font: Preferences windowTitleFont).
	""
	self addMorphBack: self spacer.
	parameters
		do: [:each | self addMorphBack: each  asMorph].
	self addMorphBack: self spacer.
	""
	self addMorphBack: self buttonsRow! !

!VideoMorphConfiguration methodsFor: 'private' stamp: 'dgd 8/10/2004 12:33'!
buttonNamed: aString action: aSymbol color: aColor help: helpString 
	"private - answer a new button"
	| button |
	button := SimpleButtonMorph new.
	button target: self.
	button label: aString.
	button color: aColor.
	button borderColor: aColor muchDarker.
	button actionSelector: aSymbol.
helpString isEmpty ifFalse:[
	button setBalloonText: helpString].
	^ button! !

!VideoMorphConfiguration methodsFor: 'building' stamp: 'dgd 8/10/2004 14:12'!
buttonsRow
	"private - create a row with accept/cancel buttons"
	| acept cancel |
	acept := self
				buttonNamed: 'Accept' translated
				action: #doAccept
				color: Color green darker
				help: 'keep changes made and close panel' translated.
	cancel := self
				buttonNamed: 'Cancel' translated
				action: #doCancel
				color: Color red darker
				help: 'cancel changes made and close panel' translated.
	^ (self inARow: {acept. cancel})
		! !

!VideoMorphConfiguration methodsFor: 'submorphs-add/remove' stamp: 'dgd 8/9/2004 20:48'!
delete
	target forgetConfigurationDialog.
super delete.! !

!VideoMorphConfiguration methodsFor: 'building' stamp: 'dgd 8/10/2004 21:18'!
doAccept
| changes |
changes := parameters
				select: [:each | each hasChanged].
changes isEmpty ifFalse:[
	target applyParameters: changes].
	self delete! !

!VideoMorphConfiguration methodsFor: 'building' stamp: 'dgd 8/9/2004 17:11'!
doCancel

	self delete! !

!VideoMorphConfiguration methodsFor: 'private' stamp: 'dgd 8/9/2004 20:04'!
inARow: aCollectionOfMorphs 
	"private - create a row of morphs"
	| row |
	row := AlignmentMorph newRow.
	row color: Color transparent;
		 vResizing: #shrinkWrap;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #leftCenter;
		 cellInset: 2.
	aCollectionOfMorphs
		do: [:each | row addMorphBack: each].
	^ row! !

!VideoMorphConfiguration methodsFor: 'initialization' stamp: 'dgd 8/10/2004 14:05'!
initialize
	super initialize.
	""
	self
		color: (Color lightYellow alpha: 0.9).
	self borderColor: self color muchDarker.
	self listDirection: #topToBottom.
	self borderWidth: 4.
	self layoutInset: 5.
	self cellInset: 2.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self useRoundedCorners! !

!VideoMorphConfiguration methodsFor: 'initialization' stamp: 'dgd 8/9/2004 20:47'!
initializeTarget: aVideoMorph parameters: aCollection 
	"initialize the receiver's parameters"
target _ aVideoMorph.
	parameters := aCollection.
	self build! !

!VideoMorphConfiguration methodsFor: 'private' stamp: 'dgd 8/9/2004 20:35'!
spacer
	^StringMorph contents: ' '! !

ObjectPropertiesMorph subclass: #VideoPropertiesMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Morphic'!

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:37'!
brightness
	"answer the receiver's brightness"
	^ myTarget getBrightness! !

!VideoPropertiesMorph methodsFor: 'building' stamp: 'dgd 8/6/2004 20:32'!
brightnessIcon
	^ Form
		extent: 22 @ 22
		depth: 16
		fromArray: #(0 0 0 0 0 65537 0 0 0 0 0 1 65536 0 0 0 65537 0 0 0 1 65536 1 65537 0 0 0 0 0 0 0 65537 65536 0 65537 0 0 65537 65537 65537 0 0 65537 0 0 0 0 65537 65537 65537 65537 65537 0 0 0 0 0 1 65537 766332664 1671258013 1324886445 65537 65536 0 0 0 0 65537 207901432 1742694367 1740530622 1673420734 1255606371 65537 0 0 0 0 65537 1392011231 1809803231 1742694334 1673420734 1604143831 65537 0 0 0 1 77229 1742695391 1809804255 1742694334 1673421758 1604148125 697106433 65536 0 0 1 85752 1742694367 1809803231 1742694334 1673420734 1604148125 1188495361 65536 0 65537 1 91037 1740531679 1742694367 1740530622 1673420734 1604148125 1467744257 65536 65537 65537 1 90013 1673422782 1740531646 1673421758 1673420701 1604148125 1467744257 65536 65537 0 1 85752 1673421758 1673421758 1673421758 1604149149 1537039261 1188429825 65536 0 0 1 76205 1606311870 1673420734 1606311837 1604148125 1537039260 629932033 65536 0 0 0 65537 1255628701 1604149149 1604149149 1537039261 1536968406 65537 0 0 0 0 65537 140724951 1537039261 1537039261 1537039260 1188431971 65537 0 0 0 0 1 65537 697124567 1467766652 1188439436 65537 65536 0 0 0 0 0 65537 65537 65537 65537 65537 0 0 0 0 65537 0 0 65537 65537 65537 0 0 65537 0 1 65537 0 0 0 0 0 0 0 65537 65536 1 65536 0 0 0 65537 0 0 0 1 65536 0 0 0 0 0 65537 0 0 0 0 0 )
		offset: 0 @ 0! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:41'!
brightnessTitle
	^ '  Brightness ({1}%)' translated format: {(self brightness * 100.0) rounded}! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:43'!
brightness: aNumber
	"answer the receiver's brightness"
	^ myTarget setBrightness: aNumber! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'kfr 1/21/2008 14:39'!
buildSlider: nameStringOrSymbol selector: aSymbol help: helpString icon: aForm 
	| title slider icon titleRow col |
	title := (nameStringOrSymbol isKindOf: Symbol)
				ifTrue: [UpdatingStringMorph new useStringFormat; getSelector: nameStringOrSymbol; target: self; growable: true; minimumWidth: 24; lock]
				ifFalse: [self lockedString: nameStringOrSymbol].
	""
	slider := SimpleSliderMorph new color: self color twiceDarker darker;
				 extent: 370 @ 10;
				 target: self;
				 actionSelector: (aSymbol , ':') asSymbol;
				 minVal: -1.0;
				 maxVal: 1.0;
				 yourself.
	slider
		adjustToValue: (self perform: aSymbol).
	""
	icon := ImageMorph new image: aForm.
	titleRow := self inARow: {icon. title}.
	titleRow hResizing: #shrinkWrap;
		 cellInset: 3.
	col := self inAColumn: {titleRow. slider}.
	""
	col borderWidth: 1;
		 borderColor: color darker;
		 color: color lighter;
		 hResizing: #shrinkWrap;

		 layoutInset: 5;
		 cellInset: 5;
		 useRoundedCorners.
helpString isEmpty ifFalse:[col 		 setBalloonText: helpString.].
	""
	^ col! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:37'!
contrast
	"answer the receiver's contrast"
	^ myTarget getContrast! !

!VideoPropertiesMorph methodsFor: 'building' stamp: 'dgd 8/7/2004 20:48'!
contrastIcon
	^ Form
		extent: 16 @ 16
		depth: 16
		fromArray: #(0 0 1 65537 65537 65536 0 0 0 1 65537 65537 65537 65537 65536 0 0 65537 77229 1324901277 835659116 348520449 65537 0 1 68708 1392011231 1742694334 837825007 837756268 69271553 65536 1 86776 1742695391 1742694367 837825007 837759471 627834881 65536 65537 766339039 1809804255 1809803231 837825007 837759471 768545990 65537 65537 1324902367 1742695391 1742694367 837825007 837759471 768550251 65537 65537 1671260094 1742694367 1742694334 837825007 837759471 768552398 65537 65537 1604150206 1740531646 1740530622 837759471 837758415 768552398 65537 65537 1324901310 1673421758 1673421758 837759471 837758415 768549227 65537 65537 699228094 1606312894 1606311870 837759471 768552399 768480454 65537 1 84695 1604149149 1604149149 768552399 768552398 560660481 65536 1 67683 1255627677 1537039261 768552399 768483691 69271553 65536 0 65537 76173 1188517756 768483691 348520449 65537 0 0 1 65537 65537 65537 65537 65536 0 0 0 1 65537 65537 65536 0 0 )
		offset: 0 @ 0! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:40'!
contrastTitle
	^ '  Contrast ({1}%)' translated format: {(self contrast * 100.0) rounded}! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 20:44'!
contrast: aNumber 
	"answer the receiver's contrast"
	^ myTarget setContrast: aNumber! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'dgd 8/6/2004 22:15'!
createComboLabel: aString target: targetObject readSelector: readSelectorSymbol writeSelector: writeSelectorSymbol options: optionsArray 
	"private - create a combo"
	| button row |
	button := SimpleButtonMorph newWithLabel: '-'.
	self
		updateButton: button
		for: targetObject
		readSelector: readSelectorSymbol
		options: optionsArray.
	button borderWidth: 1;
		 cornerStyle: #square;
		 borderColor: #inset;
		 color: self color darker.
	button target: self;
		 actionSelector: #popUpComboTarget:readSelector:writeSelector:options:button:;
		 arguments: {targetObject. readSelectorSymbol. writeSelectorSymbol. optionsArray. button}.
	""
	row := AlignmentMorph newRow.
	row borderWidth: 1;
		 borderColor: color darker;
		 color: color lighter;
		 hResizing: #shrinkWrap;
		 layoutInset: 5;
		 cellInset: 5;
		 useRoundedCorners.
	row
		addMorphBack: (StringMorph contents: aString , ': ').
	row addMorphBack: button.
	^ row! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/9/2004 20:40'!
doConfigureVideoDevice
	myTarget configureVideoDevice! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'dgd 8/10/2004 12:25'!
getLabelFor: targetObject readSelector: readSelectorSymbol options: optionsArray 
	| currentValue |
	currentValue := targetObject perform: readSelectorSymbol.
	^ (optionsArray includes: currentValue)
		ifTrue: [currentValue]
		ifFalse: [^ '<unknown option>' translated]! !

!VideoPropertiesMorph methodsFor: 'initialization' stamp: 'dgd 8/6/2004 21:37'!
initialize
	"initialize the receiver"
	super initialize.
	""
	myTarget isNil
		ifTrue: [myTarget := RectangleMorph new openInWorld].
	self
		color: (Color
				r: 0.476
				g: 0.575
				b: 0.869).
	self borderColor: self color darker.
	self rebuild ! !

!VideoPropertiesMorph methodsFor: 'building' stamp: 'dgd 8/6/2004 20:19'!
paneForAutoExtentToggle


	^self inARow: {
		self
			directToggleButtonFor: myTarget 
			getter: #autoExtent setter: #switchAutoExtent
			help: 'Turn auto-extent on or off' translated.
		self lockedString: ' Auto Extent' translated.
	}

! !

!VideoPropertiesMorph methodsFor: 'building' stamp: 'dgd 8/8/2004 20:04'!
paneForVideoParameters
	| resolutionCombo brightnessSlider contrastSlider configureButton button |
	brightnessSlider := self
				buildSlider: #brightnessTitle
				selector: #brightness
				help: 'Drag in here to change the Brightness'
				icon: self brightnessIcon.
	contrastSlider := self
				buildSlider: #contrastTitle
				selector: #contrast
				help: 'Drag in here to change the Contrast'
				icon: self contrastIcon.
	resolutionCombo := self
				createComboLabel: 'resolution'
				target: self
				readSelector: #resolution
				writeSelector: #resolution:
				options: VideoMorph resolutions.
	configureButton := self
				buttonNamed: 'Configure Video Device' translated
				action: #doConfigureVideoDevice
				color: color lighter
				help: 'press here to configure the video device' translated.
	button := configureButton submorphs anyOne.
	button borderWidth: 2;
		 borderRaised;
		 extent: button extent + 6.
	""
	^ (self inAColumn: {brightnessSlider. contrastSlider. resolutionCombo. configureButton}) cellPositioning: #topLeft;
		 layoutInset: 0;
		 cellInset: 2! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'dgd 8/6/2004 21:29'!
performComboOption: writeSelectorSymbol argument: argumentObject readSelector: readSelectorSymbol target: targetObject button: button options: optionsArray 
	targetObject perform: writeSelectorSymbol with: argumentObject.
	""
	self
		updateButton: button
		for: targetObject
		readSelector: readSelectorSymbol
		options: optionsArray! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'dgd 8/6/2004 22:11'!
popUpComboTarget: targetObject readSelector: readSelectorSymbol writeSelector: writeSelectorSymbol options: optionsArray button: button 
	| menu |
	menu := MenuMorph new.
	menu color: self color twiceLighter.
	optionsArray
		do: [:option | ""
			menu
				add: option 
				target: self
				selector: #performComboOption:argument:readSelector:target:button:options:
				argumentList: {writeSelectorSymbol. option . readSelectorSymbol. targetObject. button. optionsArray}].
	menu popUpInWorld! !

!VideoPropertiesMorph methodsFor: 'building' stamp: 'dgd 8/7/2004 21:39'!
rebuild
	self removeAllMorphs.
	self addARow: {self
			lockedString: ('Properties for {1}' translated format: {myTarget externalName})}.
	self addARow: {self inAColumn: {self paneForCornerRoundingToggle. self paneForStickinessToggle. self paneForLockedToggle. self paneForAutoExtentToggle}}.
	self addARow: {self paneForVideoParameters}.
	self addARow: {self paneForBorderColorPicker. self paneForShadowColorPicker}.
	self addARow: {self
			buttonNamed: 'Accept' translated
			action: #doAccept
			color: color lighter
			help: 'keep changes made and close panel' translated. self
			buttonNamed: 'Cancel' translated
			action: #doCancel
			color: color lighter
			help: 'cancel changes made and close panel' translated}.
	thingsToRevert := Dictionary new.
	thingsToRevert at: #hasDropShadow: put: myTarget hasDropShadow.
	thingsToRevert at: #shadowColor: put: myTarget shadowColor.
	thingsToRevert at: #borderColor: put: myTarget borderColor.
	thingsToRevert at: #borderWidth: put: myTarget borderWidth.
	thingsToRevert at: #cornerStyle: put: myTarget cornerStyle.
	thingsToRevert at: #sticky: put: myTarget isSticky.
	thingsToRevert at: #lock: put: myTarget isLocked.
	thingsToRevert at: #autoExtent: put: myTarget autoExtent.
	thingsToRevert at: #setContrast: put: myTarget getContrast.
	thingsToRevert at: #setBrightness: put: myTarget getBrightness.
	thingsToRevert at: #setResolution: put: myTarget getResolution! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 21:41'!
resolution
	"answer the receiver's resolution"
	^ myTarget getResolution! !

!VideoPropertiesMorph methodsFor: 'actions' stamp: 'dgd 8/6/2004 21:41'!
resolution: aSymbol 
	"change the receiver's resolution"
	^ myTarget setResolution: aSymbol! !

!VideoPropertiesMorph methodsFor: 'widget creation' stamp: 'dgd 8/6/2004 22:14'!
updateButton: button for: targetObject readSelector: readSelectorSymbol options: optionsArray 
	| label |
	label := self
				getLabelFor: targetObject
				readSelector: readSelectorSymbol
				options: optionsArray.
	button label: '  ',label,'  '! !

!Player methodsFor: '*VideoForSqueak-playing commands' stamp: 'dgd 3/12/2007 11:27'!
configureVideoDevice
	self sendMessageToCostume: #configureVideoDevice! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:28'!
getAutoExtent
	"answer whateve the receiver is in auto extent mode"
	^ costume renderedMorph getAutoExtent! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:28'!
getContrast
	"Answer the numeric value contained in my costume"
	^ costume renderedMorph getContrast! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:29'!
getLastFrame
	"Answer the lastFrame in my costume"
	^ costume renderedMorph getLastFrame assuredPlayer! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:29'!
getResolution
	"Answer the numeric value contained in my costume"
	^ costume renderedMorph getResolution! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:28'!
getVideoBrightness
	"Answer the numeric value contained in my costume"
	^ costume renderedMorph getBrightness! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:29'!
setAutoExtent: aBoolean 
	"Set the receiver's boolean value. This is passed on to the costume"
	costume renderedMorph setAutoExtent: aBoolean! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:30'!
setContrast: amt 
	"Set the receiver's numeric value to the amount. This is passed 
	on to the costume"
	costume renderedMorph setContrast: amt! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:30'!
setResolution: aSymbol 
	"Set the receiver's value. This is passed on to the costume"
	costume renderedMorph setResolution: aSymbol! !

!Player methodsFor: '*VideoForSqueak-slot getters/setters' stamp: 'dgd 3/12/2007 11:29'!
setVideoBrightness: amt 
	"Set the receiver's numeric value to the amount. This is passed 
	on to the costume"
	costume renderedMorph setBrightness: amt! !

ProtoObject subclass: #VideoForLinuxPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Core'!

!VideoForLinuxPlugin commentStamp: 'dgd 8/1/2004 21:04' prior: 0!
Plugin to access Video4Linux devices.
!

!VideoForLinuxPlugin class methodsFor: 'translation' stamp: 'dgd 6/26/2004 18:12'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with 
	the plugin, here is where you want to flag"
	^ true! !

!VideoForLinuxPlugin class methodsFor: 'translation' stamp: 'dgd 2/28/2007 16:53'!
translateIn: fullDirectoryPathString
	" 
	VideoForLinuxPlugin translateIn: '/home/dgd/squeak-vm37/src/plugins/VideoForLinuxPlugin/'.
	VideoForLinuxPlugin translateIn: '/home/dgd/SqueakVMSource/squeak-svn/platforms/unix/plugins/VideoForLinuxPlugin/'.
	"
	| directory |
	directory := FileDirectory forFileName: fullDirectoryPathString.
	directory assureExistence.
	self translateInDirectory: directory doInlining: true.
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/1/2007 17:45'!
clipPixel: pixel
	| result |
	self inline: true.
	result := pixel max: 0.
	^ result min: 255.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 13:08'!
copyFrom: src2 into16: dest2 destSize: destSize brightness: brightness contrast: contrast 
	|  dest src final |
	self inline: true.
	self var: #device		type: 'Device'.
	self var: #brightness	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #dest2		type: 'unsigned char*'.
	self var: #dest			type: 'unsigned char*'.
	self var: #src2			type: 'unsigned char*'.
	self var: #src			type: 'unsigned char*'.
	self var: #final			type: 'unsigned char*'.
	self var: #cont			type: 'double'.
	dest := dest2.
	src := src2.
	final := dest + (destSize * 2).
	(contrast = 0.0 and: [brightness = 0.0]) ifTrue: [
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				into16Bits: dest.
			dest := dest + 2.
			src := src + 3.
		].
	]
	ifFalse: [
		| brig256 cont contInteger |
		brig256 := (brightness * 256) asInteger.
		cont := 1.0 + contrast.
		contInteger := (cont * cont * 32767) asInteger.
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				brightness256: brig256 contrastFactor2: contInteger
				into16Bits: dest.
			dest := dest + 2.
			src := src + 3.
		].
	].
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 13:08'!
copyFrom: src2 into32: dest2 destSize: destSize brightness: brightness contrast: contrast 
	|  dest src final |
	self inline: true.
	self var: #device		type: 'Device'.
	self var: #brightness	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #dest2		type: 'unsigned char*'.
	self var: #dest			type: 'unsigned char*'.
	self var: #src2			type: 'unsigned char*'.
	self var: #src			type: 'unsigned char*'.
	self var: #final			type: 'unsigned char*'.
	self var: #cont			type: 'double'.
	dest := dest2.
	src := src2.
	final := dest + (destSize * 4).
	(contrast = 0.0 and: [brightness = 0.0]) ifTrue: [
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				into32Bits: dest.
			dest := dest + 4.
			src := src + 3.
		].
	]
	ifFalse: [
		| brig256 cont contInteger |
		brig256 := (brightness * 256) asInteger.
		cont := 1.0 + contrast.
		contInteger := (cont * cont * 32767) asInteger.
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				brightness256: brig256 contrastFactor2: contInteger
				into32Bits: dest.
			dest := dest + 4.
			src := src + 3.
		].
	].
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/2/2007 15:30'!
height: device 
	self inline: true.
	self var: #device type: 'Device'.
	^ self cCode: 'device->vwindow.height'! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/1/2007 17:46'!
pixel: pixel brightness256: brightness contrastFactor2: contrastFactor 
	| result |
	self inline: true.
	result := (pixel - 128 * (contrastFactor / 32767.0)) asInteger + 128 + brightness.
	^ result.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 8/1/2004 20:41'!
primitiveDeviceClose
	| device |
	self export: true. 
	self var: #device type: 'Device'.
	device := self
				cCoerce: (interpreterProxy stackIntegerValue: 0)
				to: 'Device'.
	self closeDevice: device.
	""
	interpreterProxy pop: 1! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 8/5/2004 22:27'!
primitiveDeviceCreate
	| palette height width devicePointer deviceID |
	self export: true.
	""
	palette := interpreterProxy stackIntegerValue: 0.
	height := interpreterProxy stackIntegerValue: 1.
	width := interpreterProxy stackIntegerValue: 2.
	deviceID := interpreterProxy stackIntegerValue: 3.
	""
	devicePointer := self cCode: '(int) createDevice(deviceID, width, height, palette)'.
	devicePointer <= 0
		ifTrue: [^ interpreterProxy primitiveFail].
	""
	interpreterProxy
		pop: 5
		thenPush: (interpreterProxy integerObjectOf: devicePointer) ! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:12'!
primitiveDeviceDescribe
	| deviceID deviceName deviceNamePointer deviceNameSize |
	self export: true.
	self var: #deviceNamePointer type: 'char*'.
	deviceName := interpreterProxy stackValue: 0.
	(interpreterProxy isBytes: deviceName)
		ifFalse: [^ interpreterProxy primitiveFail].
	deviceNamePointer := interpreterProxy firstIndexableField: deviceName.
	deviceNameSize := interpreterProxy byteSizeOf: deviceName.
	deviceNameSize = 32
		ifFalse: [^ interpreterProxy primitiveFail].
	deviceID := interpreterProxy stackIntegerValue: 1.
	self cCode: 'describeDevice(deviceID, deviceNamePointer)'.
	interpreterProxy pop: 2.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:05'!
primitiveDeviceGetHeight
	| device result |
	self export: true.
	self var: #device type: 'Device'.
	device := self cCoerce: (interpreterProxy stackIntegerValue: 0) to: 'Device'.
	result := self cCode: 'device->vwindow.height'.
	interpreterProxy
			pop: 2
			thenPush: (interpreterProxy integerObjectOf: result)! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:05'!
primitiveDeviceGetWidth
	| device result |
	self export: true.
	self var: #device type: 'Device'.
	device := self cCoerce: (interpreterProxy stackIntegerValue: 0) to: 'Device'.
	result := self cCode: 'device->vwindow.width'.
	interpreterProxy
			pop: 2
			thenPush: (interpreterProxy integerObjectOf: result).
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 14:25'!
primitiveDeviceNextFrameIntoBrightnessContrastFormDepth
	| formDepth contrast brightness bitsArrayPointer device src |
	self export: true.
	self var: #device		type: 'Device'.
	self var: #brightness 	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #src			type: 'unsigned char*'.
	formDepth := interpreterProxy stackIntegerValue: 0.
	contrast := interpreterProxy stackFloatValue: 1.
	contrast := contrast min: 1.0.
	contrast := contrast max: -1.0.
	brightness := interpreterProxy stackFloatValue: 2.
	brightness := brightness min: 1.0.
	brightness := brightness max: -1.0.
	bitsArrayPointer := interpreterProxy stackValue: 3.
	interpreterProxy success: (interpreterProxy isPointers: bitsArrayPointer) not.
	interpreterProxy failed ifTrue: [^nil].
	device := self cCoerce: (interpreterProxy stackIntegerValue: 4) to: 'Device'.
	"Capture"
	(self captureFrameFromDevice: device)
		ifFalse: [^interpreterProxy primitiveFail].
	"Convert to RGB24"
	(self convertBufferTo24: device)
		ifFalse: [^interpreterProxy primitiveFail].
	src := self cCode: 'device->buffer24'.
	"Convert"
	(formDepth = 16) ifTrue:[
		self
			copyFrom: src
			into16: (self cCoerce: (interpreterProxy firstIndexableField: bitsArrayPointer) to: 'unsigned char*')
			destSize: device width * device height
			brightness: brightness
			contrast: contrast.
	]
	ifFalse:[
		self
			copyFrom: src
			into32: (self cCoerce: (interpreterProxy firstIndexableField: bitsArrayPointer) to: 'unsigned char*')
			destSize: device width * device height
			brightness: brightness contrast: contrast.
	].
	interpreterProxy pop: 5.
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 12:56'!
storeRed: red green: green blue: blue brightness256: brig256 contrastFactor2: contInteger into16Bits: dest
	| r g b sr sg sb |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	r := self pixel: red brightness256: brig256 contrastFactor2: contInteger.
	r := self clipPixel: r.
	g := self pixel: green brightness256: brig256 contrastFactor2: contInteger.
	g := self clipPixel: g.
	b := self pixel: blue brightness256: brig256 contrastFactor2: contInteger.
	b := self clipPixel: b.
	sr := r bitShift: -3.
	sg := g bitShift: -3.
	sb := b bitShift: -3.
	dest at: 0 put: ((sg bitShift: 5) bitOr: sb).
	dest at: 1 put: (((sr bitShift: 2) bitOr: (sg bitShift: -3)) bitOr: 128 "alpha bit").
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:54'!
storeRed: red green: green blue: blue brightness256: brig256 contrastFactor2: contInteger into32Bits: dest
	| r g b |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	r := self pixel: red brightness256: brig256 contrastFactor2: contInteger.
	r := self clipPixel: r.
	g := self pixel: green brightness256: brig256 contrastFactor2: contInteger.
	g := self clipPixel: g.
	b := self pixel: blue brightness256: brig256 contrastFactor2: contInteger.
	b := self clipPixel: b.
	dest at: 0 put: b.
	dest at: 1 put: g.
	dest at: 2 put: r.
	dest at: 3 put: 255.	"alpha"
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 12:56'!
storeRed: red green: green blue: blue into16Bits: dest
	| sr sg sb |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	sr := red bitShift: -3.
	sg := green bitShift: -3.
	sb := blue bitShift: -3.
	dest at: 0 put: ((sg bitShift: 5) bitOr: sb).
	dest at: 1 put: (((sr bitShift: 2) bitOr: (sg bitShift: -3)) bitOr: 128 "alpha bit").
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:53'!
storeRed: red green: green blue: blue into32Bits: dest
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	dest at: 0 put: blue.
	dest at: 1 put: green.
	dest at: 2 put: red.
	dest at: 3 put: 255.	"alpha"
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:00'!
width: device 
	self inline: true.
	self var: #device type: 'Device'.
	^ self cCode: 'device->vwindow.width'! !

SymbolListType subclass: #ImageResolutionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Morphic'!

!ImageResolutionType commentStamp: 'dgd 8/1/2004 21:04' prior: 0!
New type for VideoDevices' eToy vocabulary!

!ImageResolutionType class methodsFor: 'class initialization' stamp: 'dgd 8/20/2006 11:44'!
initialize
	Vocabulary initialize! !

!ImageResolutionType methodsFor: 'initialization' stamp: 'dgd 7/1/2004 13:30'!
initialize
	"initialize the receiver's"
	super initialize.
	""
	self vocabularyName: #ImageResolution.
	self symbols: VideoMorph resolutions! !

!ImageResolutionType methodsFor: 'tiles' stamp: 'dgd 8/20/2006 11:30'!
representsAType
	^ true! !

UpdatingStringMorph subclass: #UpdatingNumericStringMorph
	instanceVariableNames: 'min max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Morphic'!

!UpdatingNumericStringMorph commentStamp: '<historical>' prior: 0!
Similar to UpdatingStringMorph, but adds some new features for handling numbers.!

!UpdatingNumericStringMorph methodsFor: 'target access' stamp: 'sw 9/13/2002 17:54'!
acceptValueFromTarget: v
	"Accept a value from my target"

	^ super acceptValueFromTarget: ((self format == #default and: [v isNumber])
		ifTrue: 
			[| t | 
			t _ v.
			min ifNotNil: [t _ t max: min].
			max ifNotNil: [t _ t min: max]]
		ifFalse:
			[v])! !

!UpdatingNumericStringMorph methodsFor: 'accessing' stamp: 'NS 6/24/2000 16:31'!
max
	^ max! !

!UpdatingNumericStringMorph methodsFor: 'accessing' stamp: 'NS 6/24/2000 16:31'!
max: aNumber
	max _ aNumber! !

!UpdatingNumericStringMorph methodsFor: 'accessing' stamp: 'NS 6/24/2000 16:32'!
min
	^ min! !

!UpdatingNumericStringMorph methodsFor: 'accessing' stamp: 'NS 6/24/2000 16:31'!
min: aNumber
	min _ aNumber! !

RectangleMorph subclass: #VideoMorph
	instanceVariableNames: 'videoSource form resolution autoExtent configurationDialog showStatistics frameCount timeToCaptureFrames statisticsCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VideoForSqueak-Morphic'!

!VideoMorph class methodsFor: 'scripting' stamp: 'sw 6/12/2007 02:02'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."
	^ #(
	(graphics
		(
			(slot graphic 	'The picture currently being worn' Graphic	 readOnly Player getVideoGraphic unused unused)
		)
	)
	(video
		(
			(command play 'Start playing the movie/sound')
			(command stop 'Stop playing the movie/sound')
			(slot isRunning 'Whether the movie/sound is being played' Boolean readOnly	Player getIsRunning unused unused)
			(slot autoExtent 'Whether the morph is in auto-extent mode' Boolean readWrite	Player getAutoExtent Player setAutoExtent:)
			(slot lastFrame 'A morph with the last frame' Player readOnly	Player getLastFrame unused unused)
			(slot resolution 'Video resolution' ImageResolution readWrite Player getResolution Player setResolution:)
			(slot brightness 'Video brightness' Number readWrite	Player getVideoBrightness Player setVideoBrightness:)
			(slot contrast 'Video contrast' Number readWrite	Player getContrast Player setContrast:)
			(command configureVideoDevice 'Open a dialog to configure the video device')
		)
	)
)
! !

!VideoMorph class methodsFor: 'parts bin' stamp: 'kfr 10/14/2011 19:38'!
descriptionForPartsBin
	^ self
		partName: 'VideoCamera' translatedNoop
		categories: {}
		documentation: 'A player for video devices like cameras, video capturers, etc.' translatedNoop

! !

!VideoMorph class methodsFor: 'class initialization' stamp: 'dgd 11/3/2006 15:18'!
initialize
	"
	VideoMorph initialize.
	"

	| morph |

	morph := self on: (VideoDevice implementation: TestDeviceImplementor new).
	morph updateForm.

	PartsBin
		cacheThumbnail: (Thumbnail new makeThumbnailFromForm: morph imageForm)
		forSymbol: 'Video Device'.
! !

!VideoMorph class methodsFor: 'parts bin' stamp: 'dgd 3/6/2007 14:00'!
newStandAlone
	^ self on: (VideoDevice default)! !

!VideoMorph class methodsFor: 'instance creation' stamp: 'dgd 6/4/2003 20:49'!
on: aVideoSource 
	"answer an instance of the receiver on aVideoSource"
	^ super new initializeOn: aVideoSource! !

!VideoMorph class methodsFor: 'misc' stamp: 'tak 10/31/2007 00:50'!
resolutions
	"answer a collection of valid resolutions"
	#('original' '256 colors' '256 grays' '4 grays' 'black and white' ) translatedNoop.
	^ #(#original #'256 colors' #'256 grays' #'4 grays' #'black and white' )! !

!VideoMorph class methodsFor: 'accessing' stamp: 'KR 11/3/2007 12:13'!
shutDown
	self stop.
	super shutDown.! !

!VideoMorph class methodsFor: 'accessing' stamp: 'KR 11/3/2007 12:13'!
stop
	self allInstancesDo: [:each | each stop].! !

!VideoMorph methodsFor: 'menus' stamp: 'KR 2/24/2008 14:45'!
addCustomMenuItems: aMenu hand: aHandMorph 
	| item |
	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu
		add: 'configure video device' translated
		target: self 
		action: #configureVideoDevice.
	item := (showStatistics == true)
				ifTrue:	['stop showing statistics (in Transcript)' translated]
				ifFalse: ['start showing statistics (in Transcript)' translated].
	aMenu
		add: item translated
		target: self
		action: #toggleShowingStatistics.
	(showStatistics == true) ifTrue:[
		aMenu
			add: 'reset statistics' translated
			target: self 
			action: #resetStatistics.
	].
! !

!VideoMorph methodsFor: 'configuration' stamp: 'dgd 8/10/2004 18:15'!
applyParameters: aCollection 
"apply the (possible changed) collection of parameters"
	videoSource isNil
		ifTrue: [^ self].
	videoSource applyParameters: aCollection! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 3/12/2007 11:36'!
arrowDeltaFor: aGetSelector 
	"Answer a number indicating the default arrow delta to be  
	used in a numeric readout with the given get-selector. This is  
	a hook that subclasses of Morph can reimplement."
	(#(#getVideoBrightness #getContrast ) includes: aGetSelector)
		ifTrue: [^ 0.1].
	^ super arrowDeltaFor: aGetSelector.! !

!VideoMorph methodsFor: 'accessing' stamp: 'dgd 8/6/2004 19:47'!
autoExtent
	"answer the receiver's autoExtent"
	^ autoExtent! !

!VideoMorph methodsFor: 'accessing' stamp: 'dgd 8/6/2004 19:45'!
autoExtent: aBoolean 
	"change the receiver's autoExtent"
	autoExtent := aBoolean.
self tryToAutoExtent! !

!VideoMorph methodsFor: 'accessing' stamp: 'dgd 8/6/2004 20:22'!
borderWidth: anInteger 
	super borderWidth: anInteger.
	self tryToAutoExtent ! !

!VideoMorph methodsFor: 'configuration' stamp: 'dgd 8/9/2004 20:51'!
bringUpConfigurationDialog
	configurationDialog comeToFront.
	configurationDialog topLeft: self topLeft + 5.
	configurationDialog flash.
! !

!VideoMorph methodsFor: 'configuration' stamp: 'dgd 8/9/2004 20:50'!
configureVideoDevice
	"creates a dialog to configure the receiver's videoSource"
	videoSource isNil
		ifTrue: [^ self].
	""
	configurationDialog isNil
		ifTrue: [self createConfigurationDialog]
		ifFalse: [self bringUpConfigurationDialog] ! !

!VideoMorph methodsFor: 'configuration' stamp: 'dgd 8/10/2004 14:59'!
createConfigurationDialog
	| parameters |
	parameters := videoSource parameters.
	parameters isEmpty
		ifTrue: [^ self inform: 'the video device has not parameters to configure' translated].
	""
	configurationDialog := VideoMorphConfiguration target: self parameters: parameters.
	self addMorphBack: configurationDialog.
	configurationDialog topLeft: self topLeft + 5! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 3/12/2007 11:36'!
defaultFloatPrecisionFor: aGetSelector 
	"Answer a number indicating the default float precision to be  
	used in a numeric readout for which the receiver provides the 
	data. Individual morphs can override this. Showing fractional  
	values for readouts of getCursor was in response to an explicit 
	request from ack"
	(#(#getVideoBrightness #getContrast  ) includes: aGetSelector)
		ifTrue: [^ 0.01].
	^ super defaultFloatPrecisionFor: aGetSelector.! !

!VideoMorph methodsFor: 'submorphs-add/remove' stamp: 'dgd 8/9/2004 19:22'!
delete
	"Remove the receiver as a submorph of its owner and make its  
	new owner be nil."

	self videoSource: nil.
	super delete.! !

!VideoMorph methodsFor: 'drawing' stamp: 'dgd 3/6/2007 18:30'!
drawOn: aCanvas 
	"draw the receiver on aCanvas"
	super drawOn: aCanvas.
	aCanvas
		drawImage: self scaledForm
		at: bounds origin + self borderWidth.
	showStatistics ifTrue:[
		statisticsCounter := statisticsCounter + 1.
		(statisticsCounter isDivisibleBy: (1000 / self stepTime)) ifTrue:[
			Transcript show: self asString , ': ' , self statisticsString; cr.
		].
	].
! !

!VideoMorph methodsFor: 'geometry' stamp: 'dgd 3/1/2007 12:02'!
extent: aPoint
 
	| newExtent |
	newExtent := autoExtent
						ifTrue: [videoSource isNil
										ifTrue: [320 @ 240]
										ifFalse: [videoSource extent + (self borderWidth * 2)]]
						ifFalse: [aPoint].
	super extent: newExtent.
! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 8/9/2004 20:47'!
forgetConfigurationDialog
configurationDialog_nil! !

!VideoMorph methodsFor: 'private' stamp: 'dgd 3/1/2007 16:49'!
freeAreaExtent
	"private - answer the extent to fill (or filled) with tha image"
	^ self extent - (self borderWidth * 2)! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 8/6/2004 19:56'!
getAutoExtent
	^ self autoExtent! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 7/3/2004 16:02'!
getBrightness
	^ videoSource isNil
		ifTrue: [0]
		ifFalse: [videoSource brightness]! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 7/3/2004 16:02'!
getContrast
	^ videoSource isNil
		ifTrue: [0]
		ifFalse: [videoSource contrast]! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 6/28/2004 11:35'!
getIsRunning
	^ videoSource notNil
		and: [videoSource isOpened]! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 7/1/2004 18:34'!
getLastFrame
	videoSource isNil
		ifTrue: [^ self presenter standardPlayer costume].
	videoSource isOpened
		ifFalse: [^ self presenter standardPlayer costume].
	""
	self updateForm.
	^ SketchMorph withForm: form deepCopy! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 7/1/2004 13:23'!
getResolution
	^ resolution! !

!VideoMorph methodsFor: 'initialization' stamp: 'dgd 3/1/2007 12:25'!
initialize
	"initialize the receiver"
	super initialize.
	autoExtent := true.
	resolution := #original.
	self initializeStatistics.
	self extent: 320 @ 240.
	self borderWidth: 0.
	self updateForm.
! !

!VideoMorph methodsFor: 'initialization' stamp: 'dgd 8/6/2004 19:45'!
initializeOn: aVideoSource 
	"initialize the receiver's videoSource"
	self videoSource: aVideoSource.
	self tryToAutoExtent! !

!VideoMorph methodsFor: 'initialization' stamp: 'dgd 3/6/2007 13:07'!
initializeStatistics
	"initialize the receiver's statistics counters"
	showStatistics := false.
	statisticsCounter := 0.
	frameCount := 0.
	timeToCaptureFrames := 0.
! !

!VideoMorph methodsFor: 'initialization' stamp: 'yo 7/5/2007 21:15'!
intoWorld: aWorld

	super intoWorld: aWorld.
	videoSource ifNotNil: [videoSource awake].
	self removeActionsForEvent: #aboutToEnterWorld.
	aWorld
		when: #aboutToLeaveWorld
		send: #outOfWorld:
		to: self
		with: aWorld.
! !

!VideoMorph methodsFor: 'halos and balloon help' stamp: 'dgd 3/1/2007 12:03'!
okayToResizeEasily
	^ self autoExtent not! !

!VideoMorph methodsFor: 'meta-actions' stamp: 'sw 5/3/2007 18:55'!
openAPropertySheet
	"Theoretically not called anymore -- #openAppropriatePropertySheet should do it."! !

!VideoMorph methodsFor: 'meta-actions' stamp: 'sw 5/3/2007 18:55'!
openAppropriatePropertySheet
	"Open a property-sheet of the type appropriate to the receiver."

	VideoPropertiesMorph basicNew
		targetMorph: self;
		 initialize;
		 openNearTarget
! !

!VideoMorph methodsFor: 'initialization' stamp: 'yo 7/5/2007 21:15'!
outOfWorld: aWorld

	super outOfWorld: aWorld.
	videoSource ifNotNil: [videoSource sleep].
	aWorld
		when: #aboutToEnterWorld
		send: #intoWorld:
		to: self
		with: aWorld.
! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 6/28/2004 11:34'!
play
	videoSource isNil
		ifFalse: [videoSource openIfCorresponds]! !

!VideoMorph methodsFor: 'stepping and presenter' stamp: 'yo 7/5/2007 21:32'!
prepareToBeSaved

	| active |
	super prepareToBeSaved.
	active _ false.
	videoSource ifNotNil: [
		active _ videoSource isOpened.
		videoSource sleep
	].
	active ifTrue: [
		self world
			when: #aboutToEnterWorld
			send: #intoWorld:
			to: self
			with: self world
	].
! !

!VideoMorph methodsFor: 'initialization' stamp: 'dgd 3/1/2007 12:58'!
resetStatistics
	self initializeStatistics.
	showStatistics := true.
! !

!VideoMorph methodsFor: 'private' stamp: 'dgd 3/1/2007 16:43'!
scaledForm
	"private - answer the form, but scaled to fit the morph"
	| freeAreaExtent formExtent outForm warpBlt |
	freeAreaExtent := self freeAreaExtent.
	formExtent := form extent.
	(freeAreaExtent = formExtent or: [formExtent isZero])
		ifTrue: [^ form].
	outForm := Form extent: freeAreaExtent depth: Display depth.
	warpBlt := WarpBlt current toForm: outForm.
	warpBlt
		sourceForm: form;
		cellSize: 2;
		combinationRule: Form over.
	warpBlt
		copyQuad: form boundingBox innerCorners toRect: (0 @ 0 extent: freeAreaExtent).
	^ outForm.
! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 8/6/2004 19:57'!
setAutoExtent: aBoolean 
	self autoExtent: aBoolean! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 8/3/2004 13:35'!
setBrightness: amt 
	videoSource isNil
		ifFalse:[videoSource brightness: amt]! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 8/3/2004 13:36'!
setContrast: amt 
	videoSource isNil
		ifFalse:[videoSource contrast: amt]! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 7/1/2004 13:37'!
setResolution: aSymbol 
	| newResolution |
	newResolution := aSymbol asSymbol.
	resolution := (self class resolutions includes: newResolution)
				ifTrue: [newResolution]
				ifFalse: [self class resolutions first]! !

!VideoMorph methodsFor: 'private' stamp: 'dgd 3/1/2007 12:47'!
statisticsString
	| averageFrameTime |
	averageFrameTime := (timeToCaptureFrames / frameCount) rounded.
	^ (averageFrameTime asString) , 'ms/frame - ' , (1000.0 / averageFrameTime) rounded asString, ' frames/sec'.
! !

!VideoMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/1/2007 16:39'!
step
	"Do some periodic activity"
	videoSource isNil
		ifTrue: [^ self].
	self updateForm.
	self changed.
! !

!VideoMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/2/2007 17:31'!
stepTime
	"Answer the desired time between steps in milliseconds"
	^ 20
! !

!VideoMorph methodsFor: 'e-toy support' stamp: 'dgd 6/28/2004 11:33'!
stop
	videoSource isNil
		ifFalse: [videoSource closeIfCorresponds]! !

!VideoMorph methodsFor: 'accessing' stamp: 'dgd 8/6/2004 20:02'!
switchAutoExtent
	^ self autoExtent: self autoExtent not! !

!VideoMorph methodsFor: 'configuration' stamp: 'dgd 3/1/2007 12:28'!
toggleShowingStatistics
	showStatistics := (showStatistics == true) not
! !

!VideoMorph methodsFor: 'private' stamp: 'dgd 8/9/2004 19:24'!
tryToAutoExtent
	"private - if corresponds, try to change the receiver's extent"

	autoExtent
		ifTrue: [self extent: 0 @ 0]! !

!VideoMorph methodsFor: 'private' stamp: 'dgd 3/5/2007 10:35'!
updateForm
	"private - update the form from the videoSource"
	| elapsedTime |
	elapsedTime := Time millisecondsToRun: [
		videoSource isNil ifTrue: [
			form := Form extent: 320 @ 240 depth: 32.
			form fillColor: Color blue twiceDarker
		]
		ifFalse: [
			form := videoSource nextFrame.
		].
		resolution == #'256 colors'
			ifTrue: [form := form asFormOfDepth: 8].
		resolution == #'256 grays'
			ifTrue: [form := form asGrayScale].
		resolution == #'4 grays'
			ifTrue: [form := form asFormOfDepth: 2].
		resolution == #'black and white'
			ifTrue: [form := form asFormOfDepth: 1].
	].
	showStatistics ifTrue:[
		frameCount := frameCount + 1.
		timeToCaptureFrames := timeToCaptureFrames + elapsedTime.
	].
! !

!VideoMorph methodsFor: 'accessing' stamp: 'dgd 3/1/2007 12:25'!
videoSource: aVideoSource 
	"change the receiver's videoSource"
	self initializeStatistics.
	videoSource == aVideoSource
		ifTrue: [^ self].
	videoSource isNil ifFalse: [
		videoSource removeActionsWithReceiver: self.
		videoSource closeIfCorresponds.
	].
	videoSource := aVideoSource.
	videoSource
		when: #extent
		send: #tryToAutoExtent
		to: self.
! !

!VideoMorph methodsFor: 'halos and balloon help' stamp: 'dgd 3/1/2007 12:03'!
wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph 
	aSelector == #addDupHandle:
		ifTrue: [^ false].
	^ super wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph.
! !
VideoDevice initialize!
ImageResolutionType initialize!
VideoMorph initialize!
